<!DOCTYPE HTML>
<html lang="en" class="sidebar-visible no-js light">
    <head>
        <!-- Book generated using mdBook -->
        <meta charset="UTF-8">
        <title>02_pydocs_pep8 - PYTHON</title>
        

        <meta content="text/html; charset=utf-8" http-equiv="Content-Type">
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="theme-color" content="#ffffff" />

        <link rel="shortcut icon" href="favicon.png">
        <link rel="stylesheet" href="css/variables.css">
        <link rel="stylesheet" href="css/general.css">
        <link rel="stylesheet" href="css/chrome.css">
        <link rel="stylesheet" href="css/print.css" media="print">

        <!-- Fonts -->
        <link rel="stylesheet" href="FontAwesome/css/font-awesome.css">
        <link href="https://fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,800italic,400,300,600,700,800" rel="stylesheet" type="text/css">
        <link href="https://fonts.googleapis.com/css?family=Source+Code+Pro:500" rel="stylesheet" type="text/css">

        <!-- Highlight.js Stylesheets -->
        <link rel="stylesheet" href="highlight.css">
        <link rel="stylesheet" href="tomorrow-night.css">
        <link rel="stylesheet" href="ayu-highlight.css">

        <!-- Custom theme stylesheets -->
        

        
    </head>
    <body>
        <!-- Provide site root to javascript -->
        <script type="text/javascript">
            var path_to_root = "";
            var default_theme = window.matchMedia("(prefers-color-scheme: dark)").matches ? "light" : "light";
        </script>

        <!-- Work around some values being stored in localStorage wrapped in quotes -->
        <script type="text/javascript">
            try {
                var theme = localStorage.getItem('mdbook-theme');
                var sidebar = localStorage.getItem('mdbook-sidebar');

                if (theme.startsWith('"') && theme.endsWith('"')) {
                    localStorage.setItem('mdbook-theme', theme.slice(1, theme.length - 1));
                }

                if (sidebar.startsWith('"') && sidebar.endsWith('"')) {
                    localStorage.setItem('mdbook-sidebar', sidebar.slice(1, sidebar.length - 1));
                }
            } catch (e) { }
        </script>

        <!-- Set the theme before any content is loaded, prevents flash -->
        <script type="text/javascript">
            var theme;
            try { theme = localStorage.getItem('mdbook-theme'); } catch(e) { }
            if (theme === null || theme === undefined) { theme = default_theme; }
            var html = document.querySelector('html');
            html.classList.remove('no-js')
            html.classList.remove('light')
            html.classList.add(theme);
            html.classList.add('js');
        </script>

        <!-- Hide / unhide sidebar before it is displayed -->
        <script type="text/javascript">
            var html = document.querySelector('html');
            var sidebar = 'hidden';
            if (document.body.clientWidth >= 1080) {
                try { sidebar = localStorage.getItem('mdbook-sidebar'); } catch(e) { }
                sidebar = sidebar || 'visible';
            }
            html.classList.remove('sidebar-visible');
            html.classList.add("sidebar-" + sidebar);
        </script>

        <nav id="sidebar" class="sidebar" aria-label="Table of contents">
            <div id="sidebar-scrollbox" class="sidebar-scrollbox">
                <ol class="chapter"><li class="expanded affix "><a href="01_python_intro.html">01 Python Intro</a></li><li class="expanded affix "><a href="02_pydocs_pep8.html" class="active">02_pydocs_pep8</a></li><li class="expanded affix "><a href="03_objects.html">03_objects</a></li><li class="expanded affix "><a href="04_py2_py3.html">04_py2_py3</a></li><li class="expanded affix "><a href="05_running_python.html">05_running_python</a></li><li class="expanded affix "><a href="lab1a.html">LAB_1a</a></li><li class="expanded affix "><a href="index.html">ReadMe</a></li></ol>
            </div>
            <div id="sidebar-resize-handle" class="sidebar-resize-handle"></div>
        </nav>

        <div id="page-wrapper" class="page-wrapper">

            <div class="page">
                
                <div id="menu-bar" class="menu-bar">
                    <div id="menu-bar-sticky-container">
                        <div class="left-buttons">
                            <button id="sidebar-toggle" class="icon-button" type="button" title="Toggle Table of Contents" aria-label="Toggle Table of Contents" aria-controls="sidebar">
                                <i class="fa fa-bars"></i>
                            </button>
                            <button id="theme-toggle" class="icon-button" type="button" title="Change theme" aria-label="Change theme" aria-haspopup="true" aria-expanded="false" aria-controls="theme-list">
                                <i class="fa fa-paint-brush"></i>
                            </button>
                            <ul id="theme-list" class="theme-popup" aria-label="Themes" role="menu">
                                <li role="none"><button role="menuitem" class="theme" id="light">Light (default)</button></li>
                                <li role="none"><button role="menuitem" class="theme" id="rust">Rust</button></li>
                                <li role="none"><button role="menuitem" class="theme" id="coal">Coal</button></li>
                                <li role="none"><button role="menuitem" class="theme" id="navy">Navy</button></li>
                                <li role="none"><button role="menuitem" class="theme" id="ayu">Ayu</button></li>
                            </ul>
                            
                            <button id="search-toggle" class="icon-button" type="button" title="Search. (Shortkey: s)" aria-label="Toggle Searchbar" aria-expanded="false" aria-keyshortcuts="S" aria-controls="searchbar">
                                <i class="fa fa-search"></i>
                            </button>
                            
                        </div>

                        <h1 class="menu-title">PYTHON</h1>

                        <div class="right-buttons">
                            <a href="print.html" title="Print this book" aria-label="Print this book">
                                <i id="print-button" class="fa fa-print"></i>
                            </a>
                            
                        </div>
                    </div>
                </div>

                
                <div id="search-wrapper" class="hidden">
                    <form id="searchbar-outer" class="searchbar-outer">
                        <input type="search" name="search" id="searchbar" name="searchbar" placeholder="Search this book ..." aria-controls="searchresults-outer" aria-describedby="searchresults-header">
                    </form>
                    <div id="searchresults-outer" class="searchresults-outer hidden">
                        <div id="searchresults-header" class="searchresults-header"></div>
                        <ul id="searchresults">
                        </ul>
                    </div>
                </div>
                

                <!-- Apply ARIA attributes after the sidebar and the sidebar toggle button are added to the DOM -->
                <script type="text/javascript">
                    document.getElementById('sidebar-toggle').setAttribute('aria-expanded', sidebar === 'visible');
                    document.getElementById('sidebar').setAttribute('aria-hidden', sidebar !== 'visible');
                    Array.from(document.querySelectorAll('#sidebar a')).forEach(function(link) {
                        link.setAttribute('tabIndex', sidebar === 'visible' ? 0 : -1);
                    });
                </script>

                <div id="content" class="content">
                    <main>
                        <h1><a class="header" href="#pydocs--pep8" id="pydocs--pep8">PyDocs &amp; PEP8</a></h1>
<h3><a class="header" href="#pydocs" id="pydocs">PyDoc(s)</a></h3>
<ul>
<li><strong>PyDocs</strong> is shorthand for <strong>Python Documentation</strong> and will be your go-to resource for everything Python. It is highly encouraged that you attempt to find the answer using PyDocs before asking an instructor or anyone else a question.</li>
<li><strong>Pydoc</strong> is a command that evokes the Python interpreter and utilizes the <strong>help()</strong> function to give you even more detail about a given object. You can also open up the Python interpreter and use help(object) <em>replacing object with the object you want to look up</em>.</li>
<li><strong>help()</strong> is a function that gives you a TON of data. For instance, object methods, module, important information, help, etc.</li>
<li>Understanding how to use PyDocs, pydoc command and help() function is not only testable... but it's an essential piece in becoming proficient in Python.</li>
</ul>
<p><strong>2.7:</strong> <a href="https://docs.python.org/2.7/"><strong>https://docs.python.org/2.7/</strong></a></p>
<p><strong>3.x:</strong> <a href="https://docs.python.org/3/"><strong>https://docs.python.org/3/</strong></a></p>
<h3><a class="header" href="#standard-library" id="standard-library">Standard Library</a></h3>
<p>The <strong>Python Standard Library</strong> contains all of the built in functionality of Python; and well, theres a lot of functionality included. The lectures will not even begin to scratch the surface of the Standard Library. With that said, you are encouraged to dive into the library and use whatever you can... whenever you can. You are not limited to just what I teach you. <strong>USE THE LIBRARY!</strong></p>
<p><strong>2.7:</strong> <a href="https://docs.python.org/2.7/library/index.html"><strong>https://docs.python.org/2.7/library/index.html</strong></a></p>
<p><strong>3.x:</strong> <a href="https://docs.python.org/3.7/library/index.html"><strong>https://docs.python.org/3.7/library/index.html</strong></a></p>
<h4><a class="header" href="#pydocs-standard-library-requirments" id="pydocs-standard-library-requirments">Pydocs Standard Library Requirments</a></h4>
<p>You are required to look up each and everything we go over, using the PyDocs/pydoc/help(), throughout this course. Why? There are lots of functions and methods that can be applied to many different things. I will teach you many things as we go, but it's your responsiblity to ensure you know as much as possible per each topic we go over.</p>
<h3><a class="header" href="#styling-and-pep8" id="styling-and-pep8">Styling and PEP8</a></h3>
<p><strong>PEP8</strong> is shorthand for <strong>Python Enhancement Protocol 8.</strong> Think of this as the bible for Python; the dos and do-nots of formatting and styling. Below are some of the more important commandments.</p>
<ul>
<li>Python is <strong>whitespace sensitive!</strong> Unlike C, C++, Java, etc, Python does not use brackets. Instead, Python utilizes an indentation system. </li>
<li><strong>Spaces</strong> are preferred over tabs, you cannot mix. <strong>PEP8</strong> commands 4 spaces per indention level (tab). <strong>Using editors with different tab settings may break code!</strong></li>
<li>To ensure you do not break your code... <strong>use spaces!</strong> (You can setup the tab button to output 4 spaces on most major text editors and IDEs)</li>
</ul>
<h3><a class="header" href="#pep8-a-hrefhttpswwwpythonorgdevpepspep-0008httpswwwpythonorgdevpepspep-0008a" id="pep8-a-hrefhttpswwwpythonorgdevpepspep-0008httpswwwpythonorgdevpepspep-0008a">PEP8: <a href="https://www.python.org/dev/peps/pep-0008/">https://www.python.org/dev/peps/pep-0008/</a></a></h3>
<h4><a class="header" href="#documenting-code" id="documenting-code">Documenting Code:</a></h4>
<p>Python brings many features we are already familiar with in other programming languages, but gives the user a bit more power in their documentation.</p>
<pre><code class="language-python"># This is a comment
</code></pre>
<pre><code class="language-python">&quot;&quot;&quot;This is a single line docstring&quot;&quot;&quot;
</code></pre>
<pre><code class="language-python">&quot;&quot;&quot;This is a multiline 
comment
</code></pre>
<pre><code class="language-python">&quot;&quot;&quot;This is a multiline docstring

Notice the separation? Let's get into that and explain it. 
&quot;&quot;&quot;
</code></pre>
<p><strong>What is the difference between Docstrings and Comments?</strong></p>
<ul>
<li><strong>Docstrings</strong> are targeted towards people who don't need to know how the code works. 
<ul>
<li>Docstrings can be converted directly into actual documentation</li>
<li>No implementation details unless they relate to the use</li>
<li>Notice the gap in the multiline docstring? 
<ul>
<li>On a multiline docstring, the first line is a short description. This should only be one line. </li>
<li>Second line is left blank to visually separate the summary from the rest of the description.</li>
<li>The following lines are used for additional details</li>
</ul>
</li>
</ul>
</li>
<li><strong>Comments</strong> are used to explain what, why and how something is going on to other programmers. These are no different than C/C++ aside from syntax.</li>
</ul>
<h2><a class="header" href="#exercise" id="exercise">Exercise</a></h2>
<ul>
<li>Take a moment to step through PEP8 and and learn the styling and formatting requirments</li>
<li>Pay most attention to the basics:
<ul>
<li>Indentation</li>
<li>Maximum line length</li>
<li>The entire comments section
<ul>
<li>Ensure to include a docstring at the top of all of your labs that includes your:
<ul>
<li>name</li>
<li>project/lab</li>
<li>date</li>
</ul>
</li>
</ul>
</li>
<li>Naming Conventions</li>
<li>Remember what else in contained within and return to PEP8 as we learn new concepts. You are expected to abide by PEP8 during the class. </li>
</ul>
</li>
</ul>
<hr />

                    </main>

                    <nav class="nav-wrapper" aria-label="Page navigation">
                        <!-- Mobile navigation buttons -->
                        
                            <a rel="prev" href="01_python_intro.html" class="mobile-nav-chapters previous" title="Previous chapter" aria-label="Previous chapter" aria-keyshortcuts="Left">
                                <i class="fa fa-angle-left"></i>
                            </a>
                        

                        
                            <a rel="next" href="03_objects.html" class="mobile-nav-chapters next" title="Next chapter" aria-label="Next chapter" aria-keyshortcuts="Right">
                                <i class="fa fa-angle-right"></i>
                            </a>
                        

                        <div style="clear: both"></div>
                    </nav>
                </div>
            </div>

            <nav class="nav-wide-wrapper" aria-label="Page navigation">
                
                    <a href="01_python_intro.html" class="nav-chapters previous" title="Previous chapter" aria-label="Previous chapter" aria-keyshortcuts="Left">
                        <i class="fa fa-angle-left"></i>
                    </a>
                

                
                    <a href="03_objects.html" class="nav-chapters next" title="Next chapter" aria-label="Next chapter" aria-keyshortcuts="Right">
                        <i class="fa fa-angle-right"></i>
                    </a>
                
            </nav>

        </div>

        

        

        
        
        
        <script type="text/javascript">
            window.playpen_copyable = true;
        </script>
        

        

        
        <script src="elasticlunr.min.js" type="text/javascript" charset="utf-8"></script>
        <script src="mark.min.js" type="text/javascript" charset="utf-8"></script>
        <script src="searcher.js" type="text/javascript" charset="utf-8"></script>
        

        <script src="clipboard.min.js" type="text/javascript" charset="utf-8"></script>
        <script src="highlight.js" type="text/javascript" charset="utf-8"></script>
        <script src="book.js" type="text/javascript" charset="utf-8"></script>

        <!-- Custom JS scripts -->
        

        

    </body>
</html>
